/*
Dozen Days of Dice episode 12: Dix Mille
Copyright (c) 2008 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package
{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.text.TextField;

	import com.blazinggames.dozendays.*;
	import com.blazinggames.dozendays.dice.*;
	import com.blazinggames.dozendays.dice.dixmille.*;
	
	[SWF(width="640", height="480", backgroundColor="#000000")]
	
	public class DixMille extends MovieClip implements IGameMode
	{
// ***** CONSTANTS ***********************************************************
		public static const PAGE1_TEXT:String = 
"This game was created for Blazing Games Inc. by Billy D. Spelchan "+
"(the person writing this).\n\n"+
"This game is part of the Dozen Days of Dice series which is a collection of "+
"Game in a Day challenges that revolve around the creation of computer "+
"versions of dice games. This episode is a version of Dix Mille "+
"which players try to be the first player to score 10,000 points. " +
"The game was created on December 13th for release on Blazing Games on "+
"December 19th.";

		public static const PAGE2_TEXT:String = 
"This program is free software; you can redistribute it and/or modify "+
"it under the terms of the GNU General Public License as published by "+
"the Free Software Foundation; either version 2 of the License, or "+
"(at your option) any later version.\n\n"+
"This program is distributed in the hope that it will be useful, "+
"but WITHOUT ANY WARRANTY; without even the implied warranty of "+
"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the "+
"GNU General Public License for more details.\n\n"+
"You should have received a copy of the GNU General Public License "+
"along with this program; if not, write to the Free Software "+
"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA";

		public static const MODE_NONE:int = 0;
		public static const MODE_TITLE:int = 1;
		public static const MODE_GAME:int = 2;
		public static const MODE_ABOUT:int = 3;

// ***** VARIABLES ***********************************************************
		
		private var _logDisplay:TextField;
		private var _mode:int;
		private var _car:Car;
		private var _title:Title;
		private var _game:DixMilleGame;
		private var _about:About;
		
// ***** CONSTRUCTOR *********************************************************

		public function DixMille()
		{
			_mode = MODE_NONE;
			_title = new Title(this, "Dix Mille", " ");
			_car = new Car(0x000080, 0x000040);
			_car.width = 256;
			_car.height = 256;
			_car.x = 0;
			_car.y = 0;
			//_game = new EverestGame(this, _title._setup);
			_game = new DixMilleGame(this, _title._setup);
			_about = new About(this);
			_about.setCaption("About Dix Mille");
			_about.addPage(PAGE1_TEXT);
			_about.addPage(PAGE2_TEXT);
			changeMode(MODE_TITLE);
			stop();
			stage.addEventListener(Event.ENTER_FRAME, handleEnterFrame);
		}
		
// ***** Functions - mode handlers ******************************************		
		
		public function changeMode(n:int):void
		{
			// remove old mode
			switch(_mode) {
				case MODE_NONE:
					break;
				case MODE_GAME:
					removeChild(_game);
					break;
				case MODE_TITLE:
					removeChild(_title);
					removeChild(_car);
					break;
				case MODE_ABOUT:
					removeChild(_about);
					break;
			}
			
			// change to the new mode
			switch(n) {
				case MODE_NONE:
					break;
				case MODE_GAME:
					_game.startGame();
					addChildAt(_game, 0);
					break;
				case MODE_TITLE:
					addChildAt(_car, 0);
					addChildAt(_title, 1);
					break;
				case MODE_ABOUT:
					addChildAt(_about, 0);
					break;
			}
			
			_mode = n;
		}
		
		public function handleEnterFrame(evt:Event):void
		{
			++_car.x;
			if (_car.x > 640)
				_car.x = -255;
		}
	
	}
}
